
var TVFoxConst = {
    SearchTermIdentifier : 'TVFOX_SEARCH_TERM',
    UpdateLabel: 'New TV Stations are available!',
	ext_id: '{2f17f610-5e97-4fed-828f-9940b7b577a4}'
};

var TVFox = {
    
    onWindowLoad : function(event){
        TVFoxSearch.initialize();  
		TVFoxInstallationObserver.register();
		
		var fnc = function(){
		    TVFox.checkFirstTime();
		};
		var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		timer.initWithCallback(fnc, 1000,Components.interfaces.nsITimer.TYPE_ONE_SHOT);
		
    },

	onWindowUnload : function(event){
		TVFoxInstallationObserver.unregister();
	},

	checkFirstTime : function(){
        firstTime = TVFoxPref.getFirstTime();
        //check also if null in case the key does not written yet for some reason
        if(firstTime == null || firstTime == true){
            this.showToolbar();
            TVFoxURL.load('http://toolbar.tv-fox.com/thankyou',null,true);
            TVFoxPref.setFirstTime(false);
            //set the new stations pref
            TVFoxPref.setNewStations();
        }
        else{
            //if it's first time i am not checking for update aviablable at all!!
            this.threadCheckUpdateAviabable();
        }
    },
    
    threadCheckUpdateAviabable: function(){
        if(TVFoxPref.isCheckNewStations()){
            TVFox.checkRequestUpdateAviabable();
            TVFoxPref.setNewStations();      
        }  
        
        var interval = 1000*60*60*12; //every half day
        var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		timer.initWithCallback(TVFox.threadCheckUpdateAviabable ,interval ,Components.interfaces.nsITimer.TYPE_ONE_SHOT);   
    },
    
    onCommandTVMenuItem : function(URL,uniqueName,title,width,height,buttonId){
        URL = TVFoxURL.legalizeURL(URL);
        var button = document.getElementById(buttonId);
        var boxObject = button.boxObject;
        var screenX = boxObject.screenX;
        var screenY = boxObject.screenY + boxObject.height;
        
        var onCompleteFunction = function(){
            var win = TVFoxWindow.getXULWindow('TVFox-TVWindowType',uniqueName);
            var xulBrowser = document.createElement('browser');
            xulBrowser.setAttribute('id',uniqueName + 'Browser');
            xulBrowser.setAttribute('flex','1');
            xulBrowser.setAttribute('autoscroll','false');
            xulBrowser.setAttribute('src',URL);
            xulBrowser.setAttribute('widht',width);
            xulBrowser.setAttribute('height',height);
            xulBrowser.setAttribute('type','content-primary');
            xulBrowser.setAttribute('style','overflow:hidden;');
            win.document.getElementById('TVFoxBrowserBox').appendChild(xulBrowser);    
        }
        
        this.openWindowAnimate('chrome://tv-fox/content/tv.xul',uniqueName,title,width,height,screenX,screenY,onCompleteFunction);
        
    },
    
    openWindowAnimate : function(chromeURL,uniqueName,title,width,height,screenX,screenY,onCompleteFunction){
        var win = TVFoxWindow.getXULWindow('TVFox-TVWindowType',uniqueName); 
        if(win){
            win.focus();
            return;
        }
        
        //check window corners
        if(screenX + width > window.screen.width){
            screenX = window.screen.width - width;
        }
    
        win = window.openDialog(chromeURL,
                         uniqueName,
                         'chrome,dependent,resizable=yes,titlebar=no,screenX=' + screenX + ',screenY=' + screenY,
                         title);    
        win.tvfoxwidth = win.tvfoxheight = 10;
        
        var baseStep = 25;
        var stepHeight;
        var stepWidth;
        if(width > height){
            stepHeight = height/baseStep;
            stepWidth = (width/height)*stepHeight;     
        }
        else{
            stepWidth = width/baseStep;
            stepHeight = (height/width)*stepWidth;    
        }
        win.tvfoxstepwidth = stepWidth;
        win.tvfoxstepheight = stepHeight;
        win.tvfoxfinalwidth = width;
        win.tvfoxfinalheight = height + 30;//extra 30 for the title bar
                
        this.animateOpen(win,onCompleteFunction);
    },
    
    animateOpen : function(win,onCompleteFunction){
        var nextWidth = win.tvfoxwidth + win.tvfoxstepwidth;
        var nextHeight = win.tvfoxheight + win.tvfoxstepheight;
        var endWidth = false;
        var endHeight = false;
        if(nextWidth >= win.tvfoxfinalwidth){
            nextWidth = win.tvfoxfinalwidth;  
            endWidth = true;
        }
        
        if(nextHeight >= win.tvfoxfinalheight){
            nextHeight = win.tvfoxfinalheight;  
            endHeight = true;
        }
        win.resizeTo(nextWidth,nextHeight);
        win.tvfoxwidth = nextWidth;
        win.tvfoxheight = nextHeight;
        
        if(endWidth && endHeight){
            if(onCompleteFunction){
                onCompleteFunction.call();
            }
            return;
        }
        else{
            var fnc = function(){
                TVFox.animateOpen(win,onCompleteFunction);
            };
            var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		    timer.initWithCallback(fnc, 5,Components.interfaces.nsITimer.TYPE_ONE_SHOT);      
        }
    },
    
    animateMinify : function(win){
        var step = win.tvfoxanimatedown ? -25 : 25;
        
        
        var nextHeight = win.tvfoxheight + step;   
        var end = false;   
        
        if(win.tvfoxanimatedown){
            if(nextHeight <= 23){
                nextHeight = 23;  
                end = true; 
            }
       }
       else{
            if(nextHeight >= win.tvfoxfinalheight){
                nextHeight = win.tvfoxfinalheight;  
                end = true; 
            }
       }
            
        win.resizeTo(win.tvfoxwidth,nextHeight);
        win.tvfoxheight = nextHeight;
        
        if(end){
            win.tvfoxanimating = false;
            return;
        }
        else{
            var fnc = function(){
                TVFox.animateMinify(win);
            };
            var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		    timer.initWithCallback(fnc, 5,Components.interfaces.nsITimer.TYPE_ONE_SHOT);      
        }
    },
    
    onClickImageMinify : function(win){
        if(win.tvfoxanimating){
            return;
        }   
        win.tvfoxanimating = true;
        win.tvfoxanimatedown = !win.tvfoxanimatedown;
        this.animateMinify(win);    
    },
    
    about : function(){
        var winAbout = TVFoxWindow.getXULWindow('TVFox-AboutWindowType','TVFox-AboutWindowName'); 
        if(winAbout){
            winAbout.focus();
            return;
        }
        window.openDialog('chrome://tv-fox/content/about.xul',
							'TVFox-AboutWindowName',
							'chrome,modal,centerscreen,chrome,resizable=no');
    },
    
    checkRequestUpdateAviabable: function(){
		
		var func = function(version){
			var url = 'http://toolbar.tv-fox.com/xpiversion.txt?nc=' + new Date().getTime();
			var responseCallback = function(data){
				var reqVersion = data;
				var resultCompareVersions = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator).compare(reqVersion,version); 
				if(resultCompareVersions == 1){
					TVFox.showUpdateAvailable();
				}
			};
        
			TVFoxRequest.request(url,responseCallback);  
		};
		
		this.processVersion(func);   
    },
    
    showUpdateAvailable: function(){
        //check if the button already exists:
        var button = document.getElementById('tvfox-update-btn');
        
        if(!button){
            var toolbarItem = document.createElement('toolbaritem');
            button = document.createElement('toolbarbutton');
            button.setAttribute('id','tvfox-update-btn');
            button.setAttribute('label',TVFoxConst.UpdateLabel);
            button.setAttribute('style','font-weight:bold;color:red;');
            button.setAttribute('oncommand','TVFoxURL.load(\'http://toolbar.tv-fox.com/tv-fox.xpi\',event);event.stopPropagation();');
            toolbarItem.appendChild(button);
            var toolbar = document.getElementById('tv-fox-toolbar');
            //insert befroe toolbar spring
            toolbar.insertBefore(toolbarItem,toolbar.lastChild);
        }
        
        button.setAttribute('tvfox-count',0);
        
        this.callAvailableEffect();
    },
    
    callAvailableEffect: function(){
        var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
	    timer.initWithCallback(this.updateAvailableEffect, 300,Components.interfaces.nsITimer.TYPE_ONE_SHOT);       
    },
    
    updateAvailableEffect: function(){
        var button = document.getElementById('tvfox-update-btn');
        var count = Number(button.getAttribute('tvfox-count'));           
        
        if(count < 4){
            count++;
            button.setAttribute('tvfox-count',count);
            
            var label = button.getAttribute('label');
            label = label ? '' : TVFoxConst.UpdateLabel;
            button.setAttribute('label',label);
            
            TVFox.callAvailableEffect();
        }
        
    },  
    
    processVersion: function(func){
		var version = false;
		var ext_manager = Components.classes["@mozilla.org/extensions/manager;1"];
		if(ext_manager){
			var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
			var addon = em.getItemForID(TVFoxConst.ext_id);
			version = addon.version;
			func.call(this,version);
		}
		else{ //new method - since Firefox 4.0
			try{
				Components.utils.import("resource://gre/modules/AddonManager.jsm");
				AddonManager.getAddonByID(TVFoxConst.ext_id, function(addon) {
					version = addon.version;
					func.call(this,version);
				});
				
			}
			catch(ex){
			
			}
		}
    },  

	showToolbar : function(){
		try{
			document.getElementById('tv-fox-toolbar').collapsed = false;
			document.persist('tv-fox-toolbar', 'collapsed');
		}
		catch(err){}
	},

	clearToolbarData : function(){
		TVFoxPrefService.deleteBranch('tvfox');
	},

	uninstall : function(){
		this.clearToolbarData();
		TVFoxURL.load('http://toolbar.tv-fox.com/uninstall',null,true);
	}
    
};




var TVFoxURL = {

    legalizeURL : function(url){
        url = url.replace(/&amp;/g,'&');
        url = url.replace(/\\'/g,"'");
        //clear all white spaces
        url = url.replace(/ /g,'');
        return url;
    },
    
    loadCurrent : function(url) {
        window._content.document.location = url;
        window.content.focus();
    },

    loadNewTab: function(url) {
        var tab = getBrowser().addTab(url);
        getBrowser().selectedTab = tab;
    },
    
    load : function(url,event,loadNewTab){
        url = this.legalizeURL(url);
        var newTab = false;
        if(loadNewTab || event && event.button == 1){
			newTab = true;
		}
		
		if(newTab){
		    this.loadNewTab(url);  
		}
		else{
		    this.loadCurrent(url);     
		}
    }
};

var TVFoxWindow = {
    
    getBrowserWindow : function() {
        var compWindow = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
        return compWindow.getMostRecentWindow('navigator:browser');
    },

    getXULWindow : function(type, name) {
        var compWindow = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);

        var enum_windows = compWindow.getEnumerator(type);

        while (enum_windows.hasMoreElements()) {
            var window = enum_windows.getNext();

            if (window.name == name) {
                return window;
            }
        }

        return null;
    }
};

var TVFoxString = {
    
    trim : function(string){
        if (!string) return '';
	    string = string.replace(/^\s+/, '');
	    string = string.replace(/\s+$/, '');
	    string = string.replace(/\s+/g, ' ');

	    return string;
    }
};

var TVFoxRequest = {
    request: function(url,callbackFunc){
        var req = new XMLHttpRequest();  
        req.open('GET', url, true);  
        req.onreadystatechange = function (aEvt) {  
            if (req.readyState == 4) {  
              if(req.status == 200){
                callbackFunc(req.responseText);  
              }
              else {
              }
            }  
        };  
        req.send(null);    
    }
};

//interface to write/read from the prefrence file(about:config) - 
//the registry of firefox
var TVFoxPrefService = 
{
	Comp : Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch),
                
	get : function(name) 
	{
		var retVal;
		try 
		{
			switch(this.Comp.getPrefType(name)) 
			{
				case this.Comp.PREF_BOOL:
					retVal = this.Comp.getBoolPref(name);
					break;
				case this.Comp.PREF_INT:
					retVal = this.Comp.getIntPref(name);
					break;
				case this.Comp.PREF_STRING:
					retVal = this.Comp.getCharPref(name);
					break;
				default:
					retVal = null;
					break;
			}
		} 
		catch(e) 
		{
			retVal = null;
		}
		
		return retVal;
	},
	
	set : function(name, value) 
	{
		if(value == null) 
		{
			this.set(name,'');
			this.Comp.clearUserPref(name);
			return true;
		}
		switch(typeof value) 
		{
			case 'boolean':
				this.Comp.setBoolPref(name, value);
				break;
			case 'number':
				this.Comp.setIntPref(name, value);
				break;
			case 'string':
				this.Comp.setCharPref(name, value);
				break;
			default:
				try 
				{
					var str = value.toString();
					this.Comp.setCharPref(name, str);
				} catch(e) 
				{
					return false;
				}
				break;
		}
		return true;
	},
	
	hasUserValue : function(name)
	{
		return 	this.Comp.prefHasUserValue(name);
	},
	
	deleteBranch : function(branchName)
	{
		this.Comp.deleteBranch(branchName);
	}

};

var TVFoxPref = {
    
    TVFoxPrefPrefix : 'tvfox.',
    
    getSearchEnginePrefName : function(){
        return this.TVFoxPrefPrefix + 'searchengine';    
    },
    
    setSearchEngine : function(index){
        return TVFoxPrefService.set(this.getSearchEnginePrefName(),index);          
    },
    
    getSearchEngine : function(){
        return TVFoxPrefService.get(this.getSearchEnginePrefName());   
    },
    
    getFirstTimePrefName : function(){
        return this.TVFoxPrefPrefix + 'firsttime';    
    },
    
    getFirstTime : function(){
        return TVFoxPrefService.get(this.getFirstTimePrefName());   
    },
    
    setFirstTime : function(bool){
        return TVFoxPrefService.set(this.getFirstTimePrefName(),bool);     
    },
    
    getNewStationsPrefName: function(){
        return this.TVFoxPrefPrefix + 'ns';        
    },
    
    getNewStations: function(){
        return Number(TVFoxPrefService.get(this.getNewStationsPrefName()));      
    },
    
    setNewStations: function(){
        var nowIntervalString = String(new Date().getTime());
        return TVFoxPrefService.set(this.getNewStationsPrefName(),nowIntervalString);       
    },
    
    isCheckNewStations: function(){
        var val = this.getNewStations();
        //if it's not set at all return false cause it's after install and the check is only for next time
        if(val){
            var halfDay = 1000*60*60*12;
            var now = new Date().getTime();
            //if half day has pass then return true;
            return (now - val)/halfDay >= 1;
        }
        else{
            this.setNewStations();
        }
        
        return false;
    }
};


var TVFoxSearch = {

    History : Components.classes['@mozilla.org/satchel/form-history;1'].getService(Components.interfaces.nsIFormHistory2 || Components.interfaces.nsIFormHistory),
    
    ignoreClick : false,
    ignoreFocus : false,

    Engines : [
            {
                name : 'yahoo',
                baseUrl : 'http://tfoxsearch.com/',
                url : 'http://tfoxsearch.com/?aid=5&Keywords=' + TVFoxConst.SearchTermIdentifier + '&tmp=toolbar_tvfox_results&',
                image : 'chrome://tv-fox/skin/yahoo.png',
                tooltip : 'Search the web'
            },
            {
                name : 'google',
                baseUrl : 'http://www.google.com/',
                url : 'http://www.google.com/search?q=' + TVFoxConst.SearchTermIdentifier,
                image : 'chrome://tv-fox/skin/google.png',
                tooltip : 'Search google'
            },
            {
                name : 'wikipedia',
                baseUrl : 'http://www.wikipedia.org/',
                url : 'http://en.wikipedia.org/wiki/' + TVFoxConst.SearchTermIdentifier,
                image : 'chrome://tv-fox/skin/wikipedia.png',
                tooltip : 'Search wikipedia'
            },
			 {
                name : 'babylon',
                baseUrl : 'http://www.babylon.com/affiliates/landing/index.php?id=2026&lang=eng',
                url : 'http://info.babylon.com/onlinebox.cgi?rt=ol&cid=2026&mr=5&tid=pop&term=' + TVFoxConst.SearchTermIdentifier + '&tl=English',
                image : 'chrome://tv-fox/skin/babylon.png',
                tooltip : 'Search babylon'
            },
            {
                name : 'youtube',
                baseUrl : 'http://www.youtube.com/',
                url : 'http://www.youtube.com/results?search_query=' + TVFoxConst.SearchTermIdentifier,
                image : 'chrome://tv-fox/skin/youtube.png',
                tooltip : 'Search youtube'
            },
            {
                name : 'torrent',
                baseUrl : 'http://www.torrent-search.ws/',
                url : 'http://www.torrent-search.ws/multi.php?q=' + TVFoxConst.SearchTermIdentifier,
                image : 'chrome://tv-fox/skin/torrent.png',
                tooltip : 'Search torrent'
            },
            {
                name : 'amazon',
                baseUrl : 'http://www.radio-toolbar.info/amazon',
                url : 'http://www.amazon.com/gp/associates/link-types/searchbox.html?tag=tvfoxtb-20&creative=374001&campaign=211041&adid=1GPQPN1CTGFVGYKXK9XS&mode=blended&keyword=' + TVFoxConst.SearchTermIdentifier + '&Submit.x=15&Submit.y=4',
                image : 'chrome://tv-fox/skin/amazon.png',
                tooltip : 'Search amazon'
            }
            ],
    
    onTextEntered : function(event){
        this.submit(event);
    },
    
    onFocus : function(event,searchBox){
        if(this.ignoreFocus){
            this.ignoreFocus = false;
        }
        else{
            searchBox.select();    
        }
    },
    
    onClick : function(event,searchBox){
        if(!this.ignoreClick && searchBox.selectionStart == searchBox.selectionEnd){
            searchBox.select(); 
        }
    },
    
    onMouseDown : function(event,searchBox){
        if(searchBox.hasAttribute('focused')){
            this.ignoreClick = true;
        }
	    else{
		    this.ignoreFocus = true;
		    this.ignoreClick = false;
		    searchBox.setSelectionRange(0, 0);
	    }
    },
    
    onInput : function(){
         
    },
    
    clearHistory : function(){
        this.History.removeEntriesForName('TVFox-Search-History');
        this.set('');
        
        //remove focus to main button
        document.getElementById('TVFox-Main').focus();
    },
    
    getSearchBox : function(){
        return document.getElementById('TVFox-SearchBox');
    },
    
    getSearchEnginesButton : function(){
        return document.getElementById('TVFox-SearchEngines');
    },
    
    getSearchEngine : function(index){
        if(typeof(index) == 'undefined'){
            index = TVFoxPref.getSearchEngine();
        }
        if(!index)index = 0;
        
        var engine = this.Engines[index];
        
        return engine;    
    },
    
    set : function(term){
        var searchbox = this.getSearchBox();
	    searchbox.value = term;
    },
    
    get : function(){
        var searchbox = this.getSearchBox();
        return searchbox.value;
    },
    
    makeSafe : function(term){
        var safeTerm = encodeURIComponent(term);
	    safeTerm = safeTerm.replace(/\'/g, '%27');
	    return safeTerm;    
    },
    
    convertTermsToURI : function(term){
        var result = '';
        var termArray = new Array();
        termArray = term.split(' ');

        for(var i=0; i<termArray.length; i++)
        {
	        if(i > 0) { result += '+'; }
	        result += this.makeSafe(termArray[i]);
        }
	    return result;
    },
    
    submit : function(event,isFromMenuItem){
        var term = this.getSearchBox().value;
        var engine = this.getSearchEngine();
        term = TVFoxString.trim(term);
        if(term != ''){
            TVFoxSearch.History.addEntry('TVFox-Search-History',term);
            term = this.convertTermsToURI(term);
            var url = engine.url.replace(/TVFOX_SEARCH_TERM/g,term);
            
            TVFoxURL.load(url,event); 
        } 
        
        if(term == '' && !isFromMenuItem){
            TVFoxURL.load(engine.baseUrl,event);   
        }
    },
    
    onCommandSearchEngine : function(event,engineIndex){
        this.updateSearchEnginesButton(engineIndex);    
        
        TVFoxPref.setSearchEngine(engineIndex);
        
        this.submit(event,true);
    },
    
    updateSearchEnginesButton : function(index){
        var engine = this.getSearchEngine(index);
        
        var button = this.getSearchEnginesButton();
        button.setAttribute('image',engine.image);
        button.setAttribute('tooltiptext',engine.tooltip);
    },
    
    initialize : function(){
        this.updateSearchEnginesButton();   
    }
    
};


var TVFoxInstallationObserver = 
{
	NSIObserverService	    : Components.classes['@mozilla.org/observer-service;1'].getService(Components.interfaces['nsIObserverService']),

	ACTION_REQUESTED_TOPIC       : 'em-action-requested',
	ITEM_INSTALLED               : 'item-installed',
	ITEM_UPGRADED                : 'item-upgraded',
	ITEM_UNINSTALLED             : 'item-uninstalled',
	ITEM_ENABLED                 : 'item-enabled',
	ITEM_DISABLED                : 'item-disabled',
	ITEM_CANCEL                  : 'item-cancel-action',
	
	
	register : function()
	{
		this.NSIObserverService.addObserver(this, this.ACTION_REQUESTED_TOPIC , false);	
	},
	
	unregister : function()
	{
		this.NSIObserverService.removeObserver(this, this.ACTION_REQUESTED_TOPIC);		
	},
	
	observe: function(aSubject, aTopic, aData)
	{	
		try 
		{
		    var extensionItem = aSubject.QueryInterface(Components.interfaces.nsIUpdateItem); 
		    if(extensionItem.id ==  '{2f17f610-5e97-4fed-828f-9940b7b577a4}')
			{
			    if(aData == this.ITEM_UNINSTALLED)
			    {
				    TVFox.uninstall();	
			    }
			    else if(aData == this.ITEM_INSTALLED || aData == this.ITEM_UPGRADED){
				    TVFox.showToolbar();
			    }
			}
			
			
		} 
		catch(err){}
	}
};